﻿function Create-ToastMsg {
	[CmdletBinding()]
	param([string]$ToastMessage)
	
$AppID = "Windows.SystemToast.Biogroup.Software"
$AppRegPath = "HKLM:\Software\Classes\AppUserModelId"
$RegPath = "$AppRegPath\$AppID"
 if (-NOT(Test-Path $RegPath)) {New-Item -Path $AppRegPath -Name $AppID -Force | Out-Null}
New-ItemProperty -Path $RegPath -Name DisplayName -Value "Programmes et fonctionnalités" -PropertyType String -Force | Out-Null
New-ItemProperty -Path $RegPath -Name IconUri -Value "%ProgramData%\BiogroupIT\Images\software.png" -PropertyType ExpandString -Force | Out-Null
New-ItemProperty -Path $RegPath -Name "ShowInActionCenter" -Value 1 -PropertyType "DWORD" -Force | Out-Null
New-ItemProperty -Path $RegPath -Name "Enabled" -Value 1 -PropertyType "DWORD" -Force | Out-Null

if ((Get-ItemProperty -Path $RegPath -Name "Enabled").Enabled -ne "1")  {
    New-ItemProperty -Path $RegPath -Name "Enabled" -Value 1 -PropertyType "DWORD" -Force | Out-Null
}

@" 
`$xml = @"
<toast scenario="reminder">
    <visual>
    <binding template="ToastGeneric">
		<image placement="hero" src="C:\ProgramData\BiogroupIT\Images\ToastHero.png"/>
        <image id="1" placement="appLogoOverride" src="C:\ProgramData\BiogroupIT\Images\ToastLogo.png"/>
        <text hint-style="Title">Biogroup</text>
        <text placement="attribution">Service IT</text>
        <group>
            <subgroup>
                <text hint-style="Base" hint-wrap="true">Installation logiciel</text>
            </subgroup>
        </group>
		<group>
            <subgroup>
				<text hint-style="body" hint-wrap="true">$ToastMessage</text>
            </subgroup>
        </group>
    </binding>
    </visual>
	<actions>
      <action content="OK" activationType="system" arguments="dismiss"/>
    </actions>
</toast>
"`@
	  
`$XmlDocument = [Windows.Data.Xml.Dom.XmlDocument, Windows.Data.Xml.Dom.XmlDocument, ContentType = WindowsRuntime]::New()
`$XmlDocument.loadXml(`$xml)
`$AppId = 'Windows.SystemToast.Biogroup.Software'
[Windows.UI.Notifications.ToastNotificationManager]::History.Clear(`$AppId)
[Windows.UI.Notifications.ToastNotificationManager, Windows.UI.Notifications, ContentType = WindowsRuntime]::CreateToastNotifier(`$AppID).Show(`$XmlDocument)

"@ | Out-File "C:\ProgramData\BiogroupIT\Staging\Toast_Message.ps1" -Encoding UTF8

$LogUser = (gwmi Win32_ComputerSystem).UserName
$action = New-ScheduledTaskAction -Execute "C:\Windows\System32\RunSilent.exe" -Argument "-File `"C:\ProgramData\BiogroupIT\Staging\Toast_Message.ps1`""
$trigger = New-ScheduledTaskTrigger -AtLogOn
$principal = New-ScheduledTaskPrincipal -UserId $LogUser
$task = New-ScheduledTask -Action $action -Trigger $trigger -Principal $principal
Register-ScheduledTask ToastMsg -InputObject $task
Start-ScheduledTask -TaskName ToastMsg
Unregister-ScheduledTask -TaskName ToastMsg -Confirm:$false
	
}

$Check = (Get-ItemProperty -Path "HKLM:\Software\BiogroupIT\CPPM" -Name "LAN_Profile" -ErrorAction Ignore).LAN_Profile

if ($Check -ne "True") {
	
	if (!(Test-Path "$($env:windir)\System32\RunSilent.exe")) {
	$header = "ZG9scGhpbnZlbnRvcnk6TUlaOTVTM1BvbXdtMjBzQ0lCSVl5QlhXVGdPS3F4dUhtS3NWR0NVWW1QaGtoMnV6Vng2VUIwU3NaNCplWFJiUA=="
	Start-Process "curl.exe" -Wait -NoNewWindow -ArgumentList "-s -H `"Authorization: Basic $header`" -O https://murloc.biogroup.network/arthas/sources/RunSilent.exe" -WorkingDirectory "$env:windir\System32"	
	}

@" 
<?xml version="1.0"?>
<LANProfile xmlns="http://www.microsoft.com/networking/LAN/profile/v1">
	<MSM>
		<security>
			<OneXEnforced>false</OneXEnforced>
			<OneXEnabled>true</OneXEnabled>
			<OneX xmlns="http://www.microsoft.com/networking/OneX/v1">
				<cacheUserData>false</cacheUserData>
				<authMode>user</authMode>
				<singleSignOn>
					<type>preLogon</type>
					<maxDelay>10</maxDelay>
					<allowAdditionalDialogs>false</allowAdditionalDialogs>
					<userBasedVirtualLan>false</userBasedVirtualLan>
				</singleSignOn>
				<EAPConfig><EapHostConfig xmlns="http://www.microsoft.com/provisioning/EapHostConfig"><EapMethod><Type xmlns="http://www.microsoft.com/provisioning/EapCommon">13</Type><VendorId xmlns="http://www.microsoft.com/provisioning/EapCommon">0</VendorId><VendorType xmlns="http://www.microsoft.com/provisioning/EapCommon">0</VendorType><AuthorId xmlns="http://www.microsoft.com/provisioning/EapCommon">0</AuthorId></EapMethod><Config xmlns="http://www.microsoft.com/provisioning/EapHostConfig"><Eap xmlns="http://www.microsoft.com/provisioning/BaseEapConnectionPropertiesV1"><Type>13</Type><EapType xmlns="http://www.microsoft.com/provisioning/EapTlsConnectionPropertiesV1"><CredentialsSource><CertificateStore><SimpleCertSelection>true</SimpleCertSelection></CertificateStore></CredentialsSource><ServerValidation><DisableUserPromptForServerValidation>false</DisableUserPromptForServerValidation><ServerNames></ServerNames><TrustedRootCA>79 b6 04 6a e4 2b 71 3d 68 ad 31 d3 4d 08 48 a5 18 3c e2 4c </TrustedRootCA></ServerValidation><DifferentUsername>false</DifferentUsername><PerformServerValidation xmlns="http://www.microsoft.com/provisioning/EapTlsConnectionPropertiesV2">true</PerformServerValidation><AcceptServerName xmlns="http://www.microsoft.com/provisioning/EapTlsConnectionPropertiesV2">false</AcceptServerName><TLSExtensions xmlns="http://www.microsoft.com/provisioning/EapTlsConnectionPropertiesV2"><FilteringInfo xmlns="http://www.microsoft.com/provisioning/EapTlsConnectionPropertiesV3"><CAHashList Enabled="true"><IssuerHash>79 b6 04 6a e4 2b 71 3d 68 ad 31 d3 4d 08 48 a5 18 3c e2 4c </IssuerHash></CAHashList></FilteringInfo></TLSExtensions></EapType></Eap></Config></EapHostConfig></EAPConfig>
			</OneX>
		</security>
	</MSM>
</LANProfile>
"@ | Out-File "C:\ProgramData\BiogroupIT\Staging\Ethernet.xml" -Encoding UTF8


Create-ToastMsg -ToastMessage "Configuration ClearPass 802.1x en cours..."

$adapter = (Get-NetAdapter | ? {($_.ConnectorPresent -eq $True) -and ($_.PhysicalMediaType -eq "802.3")}).Name

Set-Service -Name dot3svc -StartupType Automatic
Start-Service -Name dot3svc
Start-Sleep -s 5
Invoke-Expression "netsh lan add profile filename='C:\ProgramData\BiogroupIT\Staging\Ethernet.xml' interface=`"$adapter`""
Start-Sleep -s 5
Invoke-Expression "reg add HKLM\SOFTWARE\BiogroupIT\CPPM /v 'LAN_Profile' /t REG_SZ /d 'True' /f"

Create-ToastMsg -ToastMessage "La configuration ClearPass 802.1x est terminée."

Start-Sleep -s 5
	
}

Remove-Item "$($env:ProgramData)\BiogroupIT\Images" -Recurse -Force
Remove-Item "$($env:ProgramData)\BiogroupIT\Staging" -Recurse -Force
Remove-Item "$($env:ProgramData)\BiogroupIT\Temp" -Recurse -Force
if (Test-Path "HKLM:\Software\Classes\AppUserModelId\Windows.SystemToast.Biogroup.Software") {Remove-Item "HKLM:\Software\Classes\AppUserModelId\Windows.SystemToast.Biogroup.Software" -Force | Out-Null}